%
% CHARAKT generuje charakterystyke kwantyzatora
%
% Podstawy i algorytmy przetwarzania sygnalow
% semestr letni 2005
%

xMin = -1;	% dolna granica przetwarzania
xMax = 1;	% gorna granica przetwarzania
nB = 4;		% liczba bitow przetwornika
N = 100		%ilosc punktow charakterystyki

% ilosc przedzialow kwantyzacji
nQ = 2^nB;		
% generowanie liniowo narastajcego pobudzenia
x = -1:(1/N):1;

clf; grid;
title('charakterystyka kwantyzatora')
xlabel('pobudzenie');	ylabel('odpowiedz')


% (1)	automatyczne generowanie rownych przedzialow kwantowania
% 		(efekt kwantyzatora rownomiernego)
%xin = [linspace(xMin, xMax, nQ+1)];
% 		
% (2) 	,,reczne'' definiowanie przedzialow kwantowania
%		(patrz KWANTN.M)
xin = [-1.0, -0.95, -0.9, -0.85 -0.75 -0.6, 0.5, 1];

% rysowanie charakterystyki
plot(x,kwantn(xin,x),'r-;skwantowany;');
hold on
plot(x,x,'b-;pobudzenie;');
legend('off')
replot