% HISTOGRAMY1 wykresla estymaty rozkladu prawdopodobienstwa i dystrybuanty I-szego rzedu procesu y=sin(2*pi*f*t+phi)
% gdzie phi to zmienna losowa o rozkladzie jednostajnym na przedziale [-pi,pi]

% Laboratorium - Podstawy i algorytmy przetwarzania sygnalow
% marzec 2005
% 


% generacja wielu obserwacji i wykreslanie histogramow
% w wybranych punktach dyskretnej osi czasu

N=5000;				% liczba obserwacji
f=1000;				% czestotliwosc sinusoidy
t1=2; t2=7;			% wybrane punkty obserwacji
T=10;
prze=100;
t=linspace(0,10/f*T,T);	% przedzial obserwacji

disp("generacja wielu obserwacji i wykreslanie histogramow\n...
w wybranych punktach dyskretnej osi czasu\n\n");

% generacja obserwacji
syg=zeros(N,length(t));
for k=1:N
	phi=rand(1)*2*pi-pi;		% losuj faze
%	syg(k,:)=sin(2*pi*f*t+phi);	% generuj sygnal 1
%	syg(k,:)=randn(1,length(t));	% generuj sygnal 2
%	syg(k,:)=rand(1,length(t));	% generuj sygnal 3
	syg(k,:)=t*rand();	% generuj sygnal 3
end

% wizualizacja czterech realizacji procesu
for i = 1:4
	subplot(2,2,i); clg; grid "on";
	plot(syg(i,:),['-r;realizacja nr ',num2str(i),';']);
endfor
disp("nacisnij dowolny klawisz...\n\n");
kbhit();

% rysuj wykresy
subplot(2,2,1);
clg;
title("pierwszy punkt na osi czasu");
%prdens(syg(:,t1),prze,"sinpdf");
%prdens(syg(:,t1),prze,"gausspdf");
prdens(syg(:,t1),prze,"unipdf");

subplot(2,2,3);
clg;
title("drugi punkt na osi czasu");
%prdens(syg(:,t2),prze,"sinpdf");
%prdens(syg(:,t2),prze,"gausspdf");
prdens(syg(:,t2),prze,"unipdf");

subplot(2,2,2);
clg;
title("pierwszy punkt na osi czasu");
%prdist(syg(:,t1),prze,"sincdf");
%prdist(syg(:,t1),prze,"gausscdf");
prdist(syg(:,t1),prze,"unicdf");

subplot(2,2,4);
clg;
title("drugi punkt na osi czasu");
%prdist(syg(:,t2),prze,"sincdf");
%prdist(syg(:,t2),prze,"gausscdf");
prdist(syg(:,t2),prze,"unicdf");

disp("nacisnij dowolny klawisz...\n\n");
kbhit();



% wykreslanie histogramu na podstawie jednej obserwacji

%N=5000;				% dlugosc obserwacji
%f=100;				% czestotliwosc sinusoidy
t=linspace(0,10/f*N,N);		% przedzial obserwacji

disp("wykreslanie histogramu na podstawie jednej obserwacji");

% generacja obserwacji
syg=zeros(1,N);
%phi=rand(1)*2*pi-pi;		% losuj faze
%syg=sin(2*pi*f*t+phi);		% generuj sygnal 1
%syg=randn(1,N);			% generuj sygnal 2
syg=rand(1,N);			% generuj sygnal 3

% rysuj wykresy
oneplot();
clg;
subplot(1,2,1);
title("histogram wykreslony\nna podstawie jednej obserwacji");
%prdens(syg,prze,"sinpdf");
%prdens(syg,prze,"gausspdf");
prdens(syg,prze,"unipdf");
subplot(1,2,2);
title("dystrybuanta empiryczna wykreslona\nna podstawie jednej obserwacji");
%prdist(syg,prze,"sincdf");
%prdist(syg,prze,"gausscdf");
prdist(syg,prze,"unicdf");
